'[]\tg@ver 1.0
Option Explicit
    
Const ForAppending = 8
Const ForReading = 1
Const ForWriting = 2
Const CreateNewFile = True
Const SHIFT_JIS = 1
Const AUTO_DETECT = 0

'globalIuWFNg
Dim bobj, fso, currentDir
Set bobj = CreateObject("basp21")
Set fso = CreateObject("Scripting.FileSystemObject")

currentDir = fso.GetAbsolutePathName(".")

Call main

Set bobj = Nothing
Set fso = Nothing

Private Sub main()
    Dim mailFileNames, i, res
    
    'R}h
    If CheckCommand() = False Then
        Exit Sub
    End If

    'V[`FbN
    mailFileNames = bobj.RcvMail(GetEnv("POPserver"), _
                                GetEnv("UserName"), _
                                GetEnv("Password"), _
                                "SAVEALL", "<" + currentDir + "\log\")
                                
    If IsArray(mailFileNames) = True Then
        
        'MʂÂ]
        For i = 0 To UBound(mailFileNames, 1)
            'R[hsjis
            res = bobj.KconvFile(mailFileNames(i), mailFileNames(i) + "_", SHIFT_JIS, AUTO_DETECT)
            If ProcPreFilters(mailFileNames(i)) = True Then
                Call TransMail(mailFileNames(i) + "_")
            End If
        Next
    Else
        If mailFileNames <> Empty Then
            Call WriteErrorMessage(mailFileNames)
        End If
    End If
    
End Sub

Sub FileReplace(ByVal fileName, ByVal pattern, ByVal repl)
    Dim res
    Dim work
    Dim srcFile, regEx
        
    Set regEx = CreateObject("VBScript.RegExp")          ' K\쐬܂B
    regEx.IgnoreCase = True        ' 啶Əʂ悤ɐݒ肵܂B
    regEx.pattern = pattern         'p^[Zbg
    regEx.Global = True   ' Ŝ悤ɐݒ肵܂B
    Set srcFile = fso.OpenTextFile(fileName, ForReading)
 
    work = srcFile.ReadAll()
    Call srcFile.Close
    
    res = regEx.Replace(work, repl)
    
    Set srcFile = fso.OpenTextFile(fileName, ForWriting)
    Call srcFile.write(res)
    Call srcFile.Close

    Set srcFile = Nothing
    Set regEx = Nothing
End Sub


Function ProcPreFilters(ByVal fileName)
    
    'vtB^
    If GetEnv("PreFilterPattern") <> Empty Then
        Call FileReplace(fileName, GetEnv("PreFilterPattern"), GetEnv("PreFilterRepl"))
    End If
    
    'tB^
    If GetEnv("Accept") <> Empty Then
        If IsArray(bobj.FGrep(fileName, GetEnv("Accept"), 1)) = True Then
             ProcPreFilters = True
             Exit Function
        End If
    End If
    
    'ۃtB^
    If GetEnv("Refuse") <> Empty Then
        If IsArray(bobj.FGrep(fileName, GetEnv("Refuse"), 1)) = True Then
             ProcPreFilters = False
             Exit Function
        End If
    End If
    
    ProcPreFilters = True
End Function

Sub ProcBodyFilters(ByRef body)
    Dim n, regEx
    
    '؂l
    n = CInt(GetEnv("MaxBody"))
    If n >= 1 Then
        body = Left(body, n)
    End If
    'Aɂ܂Ƃ߂
    Set regEx = CreateObject("VBScript.RegExp")          ' K\쐬܂B
    regEx.IgnoreCase = True        ' 啶Əʂ悤ɐݒ肵܂B
    regEx.Global = True   ' Ŝ悤ɐݒ肵܂B
   
    n = CInt(GetEnv("Truncate"))
    If n >= 2 Then
	    regEx.pattern = "(.)(\1){" + CStr(n - 1) + ",}"         'p^[Zbg
        body = regEx.Replace(body, "$1")
    End If
    
End Sub

'falseԂƎsȂ
Function CheckCommand()
    Dim mailTitles
    Dim mailID
    
    mailTitles = bobj.RcvMail(GetEnv( "POPserver"), _
                                GetEnv( "UserName"), _
                                GetEnv( "Password"), _
                                "LIST", "<" + currentDir + "\log\")
    If IsArray(mailTitles) = False Then
        '[ĂȂ̂HƂG[H
        If Left(mailTitles, Len("No Message")) <> "No Message" Then
            WriteErrorMessage (mailTitles)
            CheckCommand = False
            Exit Function
        End If
    End If
    
    'JnR}h̏
    mailID = FindCommand(mailTitles, "start", GetEnv("AdminUserAddress"))
    If mailID > 0 Then
        'R}h[̍폜
        Call DeleteMail(mailID)
        'mF[̔
        Call SendAckMail("started.")
        'VXeԂ̕ύX
        Call SetEnv("Status", "started")
        CheckCommand = True
        Exit Function
    End If
    'IR}h̏
    mailID = FindCommand(mailTitles, "stop", GetEnv("AdminUserAddress"))
    If mailID > 0 Then
        'R}h[̍폜
        Call DeleteMail(mailID)
        'mF[̔
        Call SendAckMail("stopped.")
        'VXeԂ̕ύX
        Call SetEnv("Status", "stopped")
        CheckCommand = False
        Exit Function
    End If
    
    'R}hĂȂƂ͐ݒt@Cɍs
    If GetEnv("Status") = "stopped" Then
        CheckCommand = False
    Else
        CheckCommand = True
    End If
    
End Function

'mailID̃[T[o폜
Sub DeleteMail(ByVal mailID)
    Dim res
    res = bobj.RcvMail(GetEnv("POPserver"), _
                                GetEnv("UserName"), _
                                GetEnv("Password"), _
                                "DELE " + CStr(mailID), "<" + currentDir + "\log\")
                                
    If Left(CStr(res), 1) <> "1" Then
        WriteErrorMessage (res)
    End If
    
End Sub

'R}hʂ̃[𑗂
Sub SendAckMail(ByRef message)

    Dim res
    
    res = bobj.SendMail(GetEnv("SMTPserver"), _
                        GetEnv("TransToAddress"), _
                        GetEnv("AdminUserAddress"), _
                        message, message, "")
                        
    If res <> Empty Then
        Call WriteErrorMessage(res)
    End If
End Sub

'[^CgɃR}h邩TB
Function FindCommand(ByRef titles, ByVal command, ByVal adminUser)
    Dim i
    Dim res, regEx
    
    If IsArray(titles) = False Then
        FindCommand = -1
        Exit Function
    End If
    
    Set regEx = CreateObject("VBScript.RegExp")       ' K\쐬܂B
    regEx.IgnoreCase = True     ' 啶ƏʂȂ悤ɐݒ肵܂B
    
    For i = 0 To UBound(titles, 1)
        res = Split(titles(i), vbTab)
        
        regEx.pattern = adminUser         ' M[U̔
        If regEx.Test(res(1)) = True Then  'Ă郆[UȂR}hsȂ
            regEx.pattern = command       ' R}h̔
            If regEx.Test(res(0)) = True Then
                FindCommand = i + 1
                Exit Function
            End If
        End If
    Next
    
    Set regEx = Nothing
    FindCommand = -1
End Function

'G[Ot@CɃG[
Sub WriteErrorMessage(ByRef errMessage)
    Dim errFile
    
    Set errFile = fso.OpenTextFile(currentDir + "\errlog.txt", ForAppending, CreateNewFile)
    Call errFile.writeline(CStr(Date) + "-" + CStr(Time) + " " + errMessage)
    Call errFile.Close
    
    Set errFile = Nothing
End Sub

Sub TransMail(ByVal fileName)

    Dim res, defaultFrom
    Dim subject, body, from
    
    subject = GetTagValue("Subject", fileName)
    '[s]΍
    from = GetTagValue("From", fileName)
    defaultFrom = GetEnv("MailFrom")
    If defaultFrom <> Empty Then
        from = defaultFrom
    End If
    
    body = GetTagValue("Body", fileName)
    
    Call ProcBodyFilters(body)
    
    res = bobj.SendMail(GetEnv("SMTPserver"), _
                        GetEnv("TransToAddress"), _
                        from, _
                        subject, body, "")
                        
    If res <> Empty Then
        Call WriteErrorMessage(res)
    End If

End Sub

't@Cǂݏo
Function GetEnv(ByVal envName)
    Dim res
    Dim path
    Dim work
    
    path = currentDir + "\setup.ini"
    res = bobj.FGrep(path, "/\[" + envName + "\]=/", 1)
	if isArray(res) = false then
		GetEnv = Empty
		Exit Function
	end if
    work = Split(res(0), "=")
    GetEnv = work(1)
End Function


't@C̐ݒ
Sub SetEnv(ByVal envName, ByVal value)
    Dim res
    Dim path
    Dim work
    Dim iniFile, regEx
        
    Set iniFile = fso.OpenTextFile(currentDir + "\setup.ini", ForReading)
 
    work = iniFile.ReadAll()
    Call iniFile.Close
    
    Set regEx = CreateObject("VBScript.RegExp")          ' K\쐬܂B
    regEx.IgnoreCase = True        ' 啶Əʂ悤ɐݒ肵܂B
    regEx.pattern = "\[" + envName + "\]=.*"         'p^[Zbg
    regEx.Global = True   ' Ŝ悤ɐݒ肵܂B
    
    res = regEx.Replace(work, "[" + envName + "]=" + value)
    
    Set iniFile = fso.OpenTextFile(currentDir + "\setup.ini", ForWriting)
    Call iniFile.write(res)
    Call iniFile.Close

    Set iniFile = Nothing
    Set regEx = Nothing
End Sub


'[wb_̈s̒loB
Function GetTagValue(ByVal tagname, ByRef fileName)
    Dim res
    res = bobj.ReadMail(fileName, tagname + ":", "")
    'ȂemptyԂ
    If IsArray(res) = False Then
        GetTagValue = Empty
        Exit Function
    End If
    GetTagValue = Right(res(0), Len(res(0)) - Len(tagname + ": "))
End Function



